VERSION 5.00
Begin VB.Form FormMain 
   Caption         =   "GnucVB"
   ClientHeight    =   4245
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3630
   LinkTopic       =   "Form1"
   ScaleHeight     =   4245
   ScaleWidth      =   3630
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox ListResults 
      Height          =   2595
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   5
      Top             =   1440
      Width           =   3375
   End
   Begin VB.CommandButton ButtonGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   300
      Left            =   2880
      TabIndex        =   4
      Top             =   720
      Width           =   615
   End
   Begin VB.Timer TimerMain 
      Interval        =   1000
      Left            =   3120
      Top             =   0
   End
   Begin VB.TextBox EditQuery 
      Height          =   285
      Left            =   720
      TabIndex        =   2
      Top             =   675
      Width           =   2055
   End
   Begin VB.Line Line1 
      X1              =   -120
      X2              =   3960
      Y1              =   480
      Y2              =   480
   End
   Begin VB.Label LabelResults 
      Caption         =   "Results"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   1200
      Width           =   2535
   End
   Begin VB.Label LabelSearch 
      Caption         =   "Search:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   615
   End
   Begin VB.Label LabelConnects 
      Caption         =   "Connecting..."
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   135
      Width           =   2415
   End
End
Attribute VB_Name = "FormMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public DnaCore   As GnucDNA.Core
Public DnaPrefs  As GnucDNA.Prefs
Public DnaMeta   As GnucDNA.Meta
Public DnaCache  As GnucDNA.Cache
Public DnaNet    As GnucDNA.Network
Public DnaSearch As GnucDNA.Search

Private WithEvents DnaSearchEvent As GnucDNA.Search
Attribute DnaSearchEvent.VB_VarHelpID = -1

Public CurrentSearchID As Integer



Private Sub ButtonGo_Click()

    ' End previous search
    DnaSearch.EndSearch (CurrentSearchID)


    ' Do Search over network
    CurrentSearchID = DnaSearch.StartSearch(EditQuery.Text)
    
    
    ListResults.SetFocus
    
End Sub

Private Sub DnaSearchEvent_OnResult(ByVal SearchID As Long, ByVal ResultID As Long)

    ListResults.AddItem (DnaSearch.GetResultName(SearchID, ResultID))
    
End Sub

Private Sub Form_Load()

    ' Init variables
    CurrentSearchID = 0
    

    ' Load DNA
    Set DnaCore = New GnucDNA.Core
    Set DnaPrefs = DnaCore.GetIPrefs
    Set DnaMeta = DnaCore.GetIMeta
    Set DnaCache = DnaCore.GetICache
    Set DnaNet = DnaCore.GetINetwork
    Set DnaSearch = DnaCore.GetISearch
    
    Set DnaSearchEvent = DnaCore.GetISearch


    ' Make sure DNA version is what we expect
    Dim CoreVersion As String
    
    CoreVersion = DnaCore.GetCoreVersion
    CoreVersion = Replace(CoreVersion, ".", "")
    
    If (CoreVersion < 903) Then End  ' Must be version 0.9.0.3 or later
    

    ' Custom Client Settings
    DnaCore.ClientName = "Test VB Client"
    DnaCore.ClientVersion = "1.0"
    DnaCore.ClientCode = "TVBC"
    DnaCore.RunPath = App.Path

    
    ' Load schemas / preferences / caches
    DnaMeta.LoadSchemaDir (App.Path + "\Schemas")
    
    DnaPrefs.LoadConfig (App.Path + "\GnuConfig.ini")
    DnaPrefs.LoadBlocked (App.Path + "\GnuBlocked.net")

    DnaCache.LoadCache (App.Path + "\GnuCache.net")
    DnaCache.LoadUltraCache (App.Path + "\GnuUltraCache.net")
    DnaCache.LoadWebCache (App.Path + "\WebCache.net")
    
    
    ' Start connecting to the network
    DnaCore.Connect
    
    
End Sub





Private Sub Form_Unload(Cancel As Integer)
    
     ' Save preferences / caches
    DnaPrefs.SaveConfig (App.Path + "\GnuConfig.ini")
    DnaPrefs.SaveBlocked (App.Path + "\GnuBlocked.net")

    DnaCache.SaveCache (App.Path + "\GnuCache.net")
    DnaCache.SaveUltraCache (App.Path + "\GnuUltraCache.net")
    DnaCache.SaveWebCache (App.Path + "\WebCache.net")

End Sub


Private Sub TimerMain_Timer()

    ' Set number of nodes we are connected to
    If (DnaCore.IsConnecting And DnaNet.GetNormalConnectedCount = 0) Then
        LabelConnects.Caption = "Connecting..."
    Else
        LabelConnects.Caption = DnaNet.GetNormalConnectedCount & " Connections"
    End If
    
    
    ' Set result count for current search
    If (DnaSearch.CountGoodResults(CurrentSearchID) = 0) Then
        LabelResults.Caption = "Results"
    Else
        LabelResults.Caption = DnaSearch.CountGoodResults(CurrentSearchID) & " Results"
    End If
    
End Sub


